﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Media.Imaging;

namespace PacmanQuiMangeCourbe
{
 public partial class Page : UserControl
 {
  public Page()
  {
   InitializeComponent();
  }
  void stb_Completed(object sender, EventArgs e)
  {
   if (rc.Children.Count > 0) StartElementaryAnimation();
   else Pacman.Opacity = 0;
  }

  void StartElementaryAnimation()
  {
   Line li = rc.Children[0] as Line;
   if (li != null)
   {
    daX.From = li.X1 - Pacman.Width / 2; daX.To = li.X2 - Pacman.Width / 2;
    daY.From = li.Y1 - Pacman.Width / 2; daY.To = li.Y2 - Pacman.Width / 2;
    // calcul de l'angle
    double H = li.Y2 - li.Y1, W = li.X2 - li.X1;
    double angleRad = Math.Atan(H / W);
    double angle = angleRad * 360 / 6.28;
    if (H < 0 && W < 0) angle += 180;
    if (W < 0 && H > 0) angle += 180;
    if (H == 0 && W < 0) angle = 180;
    if (W == 0 && H < 0) angle = -90;
    rotPacman.Angle = angle;
    rc.Children.RemoveAt(0);
    switch (rc.Children.Count % 2)
    {
     case 0: imgPacman.Source = new BitmapImage(new Uri("Pacman2.png", UriKind.Relative)); break;
     case 1: imgPacman.Source = new BitmapImage(new Uri("Pacman1.png", UriKind.Relative)); break;
    }
    stb.Begin();
   }
  }

  bool bDrawing;
  double xPrevPt, yPrevPt;
  void rc_MouseLeftButtonDown(object sender, MouseEventArgs e)
  {
   rc.Children.Clear();
   bDrawing = true;
   xPrevPt = e.GetPosition(rc).X;  // retenir position précédente
   yPrevPt = e.GetPosition(rc).Y;
  }
  void rc_MouseLeftButtonUp(object sender, MouseEventArgs e)
  {
   bDrawing = false;
   Pacman.Opacity = 1;
   StartElementaryAnimation();
  }
  void rc_MouseMove(object sender, MouseEventArgs e)
  {
   if (bDrawing)
   {
    Line li = new Line();
    double xCurPt = e.GetPosition(rc).X;
    double yCurPt = e.GetPosition(rc).Y;
    li.X1 = xPrevPt; li.Y1 = yPrevPt;
    li.X2 = xCurPt; li.Y2 = yCurPt;
    li.Stroke = new SolidColorBrush(Colors.Blue); li.StrokeThickness = 2;
    rc.Children.Add(li);
    xPrevPt = xCurPt; yPrevPt = yCurPt;
   }
  } 
 }
}
